﻿package
{
    import flash.display.Sprite;
    import flash.events.MouseEvent;
    import org.libspark.betweenas3.BetweenAS3;
    import org.libspark.betweenas3.tweens.ITween;
    import org.libspark.betweenas3.easing.*;
    
    public class Lesson8 extends Sprite
    {
        public function Lesson8()
        {
            var box:Box = addNewBox(0, 0);
            
            // Create a tween
            _t = BetweenAS3.bezier(box,
                {x: 400, y: 400}, // to
                {x: 0, y: 0}, // from
				
				{
                    x: [800, 0],
                    y: [0, 400]
                }, // control points
				
                3.0, // time
                Cubic.easeOut // easing
            );
            	
			_t = BetweenAS3.serial( _t, BetweenAS3.reverse(_t.clone()));
			
            // Set to be never stop
            _t.stopOnComplete = false;
			
            // Start the tween
            _t.play();
            
            // MouseUp listener
            stage.addEventListener(MouseEvent.MOUSE_UP, mouseUpHandler);
        }
        
        private var _t:ITween;
        
        private function mouseUpHandler(e:MouseEvent):void
        {
            // Stop the tween if playing
            // Start the tween if stopping
            _t.togglePause();
            
            // Note: You can use gotoAndPlay(time) or gotoAndStop(time) too.
        }
        
        private function addNewBox(x:Number, y:Number):Box
        {
            var box:Box = new Box();
            box.x = x;
            box.y = y;
            addChild(box);
            return box;
        }
    }
}

import flash.display.Sprite;
 
internal class Box extends Sprite
{
	public function Box()
	{
		graphics.beginFill(0);
		graphics.drawRect(-10, -10, 20, 20);
		graphics.endFill();
	}
}