package album.view 
{
	import flash.display.Bitmap;
	import flash.display.DisplayObject;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.net.navigateToURL;
	import flash.net.URLRequest;
	import org.libspark.betweenas3.BetweenAS3;
	import org.libspark.betweenas3.easing.Circ;
	/**
	 * ...
	 * @author Katsushi Suzuki
	 */
	public class Footer extends Sprite
	{
		private var img:Class;
		
		[Embed(source="/asset/title.png")]
		public var Image01:Class;
		
		[Embed(source="/asset/BetweenAS3_txt.png")]
		public var Image02:Class;	
		
		[Embed(source="/asset/bgm.png")]
		public var Image03:Class;		
		
		private var _bitmap1:Bitmap;
		private var _bitmap2:Bitmap;
		private var _bitmap3:Bitmap;
		private var _link1:Sprite;
		private var _link2:Sprite;
		
		public function Footer() 
		{
			_bitmap1 = new Image01() as Bitmap;
			_bitmap2 = new Image02() as Bitmap;
			_bitmap3 = new Image03() as Bitmap;
			addChild(_bitmap1);
			
			_link1 = addChild(new Sprite()) as Sprite;
			_link2 = addChild(new Sprite()) as Sprite;
			_link1.addChild(_bitmap2);
			_link2.addChild(_bitmap3);
			_link1.alpha = 0.5;
			_link2.alpha = 0.5;
			_link1.buttonMode = true;
			_link2.buttonMode = true;
			
			_link1.addEventListener(MouseEvent.MOUSE_OVER, overHandler);
			_link2.addEventListener(MouseEvent.MOUSE_OVER, overHandler);
			
			_link1.addEventListener(MouseEvent.MOUSE_OUT, outHandler);
			_link2.addEventListener(MouseEvent.MOUSE_OUT, outHandler);
			
			_link1.addEventListener(MouseEvent.MOUSE_DOWN, clickHandler);
			_link2.addEventListener(MouseEvent.MOUSE_DOWN, clickHandler);
		}
		
		private function outHandler(e:MouseEvent):void 
		{
			BetweenAS3.tween( e.target, { alpha: 0.5 }, null, 0.3, Circ.easeOut).play();
		}
		
		private function overHandler(e:MouseEvent):void 
		{
			BetweenAS3.tween( e.target, { alpha: 1 }, null, 0.3, Circ.easeOut).play();
		}
		
		private function clickHandler(e:MouseEvent):void 
		{
			var url:String = e.target == _link1 ?"http://www.libspark.org/wiki/BetweenAS3/en":"http://propanmode.net/";
			navigateToURL(new URLRequest(url) );
		}
		
		
		public function onResize(w:Number, h:Number):void
		{
			this.y = h - 10;
			_bitmap1.y = -_bitmap1.height;
			_bitmap2.y = -_bitmap2.height + 1;
			_bitmap3.y = -_bitmap3.height + 1;
			
			_bitmap1.x = 10;
			_bitmap3.x = w - _bitmap3.width - 10;
			_bitmap2.x = _bitmap3.x - 18 -_bitmap2.width;
		}
		
	}

}