package album.view 
{
	import album.model.ContentsModel;
	import album.vo.PhotoVo;
	import flash.display.Bitmap;
	import flash.display.Loader;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.MouseEvent;
	import flash.net.URLRequest;
	import org.libspark.betweenas3.BetweenAS3;
	import org.libspark.betweenas3.easing.Cubic;
	import org.libspark.betweenas3.easing.Expo;
	import org.libspark.betweenas3.tweens.ITween;
	/**
	 * ...
	 * @author Katsushi Suzuki
	 */
	public class MediumView extends Sprite
	{		
		private var _base:Sprite;
		private var _loader:Loader;
		private var _t:ITween;
		
		
		public function MediumView() 
		{
			buttonMode = true;
			ContentsModel.instance.addEventListener("update", updateHandler);
			
			_loader = new Loader();
			_loader.contentLoaderInfo.addEventListener(Event.COMPLETE, loadImageCompleteHandler);
			_loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, loadImageErrorHandler);
			addChild(_loader);
			
			_base = addChild(new Sprite()) as Sprite;
			_base.addChild(_loader);
		}
		
		private function updateHandler(e:Event):void
		{
			if (ContentsModel.instance.photoVo == null) {
			}
			else {
				load();
			}
		}
		
		private function load():void
		{
			if(_t)_t.stop();
			_t = BetweenAS3.tween( this, { scaleX:0.8, scaleY:0.8, alpha:0 }, null, 0.5, Expo.easeOut);
			_t.onComplete = function():void {
				var vo:PhotoVo = ContentsModel.instance.photoVo;
				var url:String = "asset/"+vo.medium;
				var req:URLRequest = new URLRequest(url);
				_loader.load(req);
			}
			_t.play();
		}
		
		
		
		private function open():void
		{
			if (_t)_t.stop();
			
			_t = BetweenAS3.tween( this, { scaleX:1, scaleY:1, alpha:1 }, null, 0.8, Cubic.easeOut);
			_t.onComplete = null;
			_t.play();
			addEventListener(MouseEvent.CLICK, clickHandler);
		}
		
		private function close():void
		{
			if(_t)_t.stop();
			_t = BetweenAS3.tween( this, { scaleX:0.8, scaleY:0.8, alpha:0 }, null, 0.5, Expo.easeOut);
			_t.onComplete = function():void {
				Bitmap(_loader.content).bitmapData.dispose();
				ContentsModel.instance.photoVo = null;
				ContentsModel.instance.update();
			}
			_t.play();
			removeEventListener(MouseEvent.MOUSE_DOWN, clickHandler);
		}
		
		
		
		private function clickHandler(e:MouseEvent):void 
		{
			close();
		}
		
		private function loadImageCompleteHandler(e:Event):void 
		{
			Bitmap(e.target.content).smoothing = true;
			
			_loader.x = -(_loader.width / 2) >> 0;
			_loader.y = -(_loader.height / 2) >> 0;
			resizePhoto();
			scaleX = scaleY = 0.8;
			alpha = 0;
			open();
		}
		
		private function loadImageErrorHandler(e:IOErrorEvent):void 
		{
		}
		
		public function onResize(w:Number, h:Number):void
		{
			x = (w / 2) >> 0;
			y = (h / 2) >> 0;
			resizePhoto();
		}
		
		private function resizePhoto():void
		{
			if (stage.stageHeight < _loader.height+40) {
				var ratio:Number = stage.stageHeight/(_loader.height+40);
				_base.scaleX = ratio;
				_base.scaleY = ratio;
			}
			
			else if (stage.stageWidth < _loader.width+80) {
				ratio = stage.stageWidth/(_loader.width+80);
				_base.scaleX = ratio;
				_base.scaleY = ratio;
			}
			
			else {
				_base.scaleX = _base.scaleY = 1;
			}
		}
		
	}

}