package album.view 
{
	import album.model.ContentsModel;
	import flash.display.Bitmap;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import org.libspark.betweenas3.BetweenAS3;
	import org.libspark.betweenas3.easing.Circ;
	/**
	 * ...
	 * @author Katsushi Suzuki
	 */
	public class Navigation extends Sprite
	{
		private var img:Class;
		
		[Embed(source="/asset/next_btn2.png")]
		public var Image04:Class;
		
		private var _bitmap1:Bitmap;
		private var _bitmap2:Bitmap;
		private var _bitmap3:Bitmap;
		private var _bitmap4:Bitmap;
		private var _prev:Sprite;
		private var _next:Sprite;
		
		public function Navigation() 
		{
			_bitmap3 = new Image04() as Bitmap;
			_bitmap4 = new Image04() as Bitmap;
			_bitmap3.scaleX = -1;
			
			_prev = addChild(new Sprite()) as Sprite;
			_next = addChild(new Sprite()) as Sprite;
			_prev.buttonMode = true;
			_next.buttonMode = true;
			_prev.y = -100;
			_next.y = -100;
			
			_prev.addEventListener(MouseEvent.MOUSE_DOWN, clickHandler);
			_next.addEventListener(MouseEvent.MOUSE_DOWN, clickHandler);
			_prev.addEventListener(MouseEvent.MOUSE_OVER, overHandler);
			_next.addEventListener(MouseEvent.MOUSE_OVER, overHandler);
			_prev.addEventListener(MouseEvent.MOUSE_OUT, outHandler);
			_next.addEventListener(MouseEvent.MOUSE_OUT, outHandler);			
			
			
			_prev.addChild(_bitmap3);
			_next.addChild(_bitmap4);
			_prev.alpha = 0.3;
			_next.alpha = 0.3;
			_bitmap3.x = -21;
			_bitmap4.x = 0;
			
			
			ContentsModel.instance.addEventListener("update", updateHandler);
		}
		
		private function overHandler(e:MouseEvent):void 
		{
			BetweenAS3.tween( e.target, { alpha: 1 }, null, 0.3, Circ.easeOut).play();
		}
		
		private function outHandler(e:MouseEvent):void 
		{
			BetweenAS3.tween( e.target, { alpha: 0.3 }, null, 0.3, Circ.easeOut).play();
		}
		
		private function clickHandler(e:MouseEvent):void 
		{
			if (e.target == _prev) {
				ContentsModel.instance.prev();
			}
			else{
				ContentsModel.instance.next();
			}
			ContentsModel.instance.update();
		}
		
		private function updateHandler(e:Event):void
		{
			if (ContentsModel.instance.photoVo == null) {
				BetweenAS3.tween( _bitmap3, { x: -21 }, null, 0.6, Circ.easeIn).play();
				BetweenAS3.tween( _bitmap4, { x: 0 }, null, 0.6, Circ.easeIn).play();
			}
			else {
				BetweenAS3.tween( _bitmap3, { x: 50 }, null, 0.6, Circ.easeOut).play();
				BetweenAS3.tween( _bitmap4, { x: -50 }, null, 0.6, Circ.easeOut).play();
			}
		}
		
		public function onResize(w:Number, h:Number):void
		{
			this.y = h / 2;
			
			_prev.x = 0;
			_next.x = w;
		}
		
	}

}