package album.view 
{
	import album.model.ContentsModel;
	import album.model.PhotoModel;
	import flash.display.Loader;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.MouseEvent;
	import flash.net.URLRequest;
	import org.libspark.betweenas3.BetweenAS3;
	import org.libspark.betweenas3.easing.Cubic;
	import org.libspark.betweenas3.easing.Expo;
	import org.libspark.betweenas3.tweens.IObjectTween;
	import org.libspark.betweenas3.tweens.ITween;
	/**
	 * ...
	 * @author Katsushi Suzuki
	 */
	public class TableView extends Sprite
	{
		private var _loadedNum:uint;
		private var _thumbnails:Array;
		
		
		public function TableView() 
		{
			ContentsModel.instance.addEventListener("update", updateHandler);
		}
		
		private function updateHandler(e:Event):void
		{
			if (ContentsModel.instance.photoVo == null) {
				open();
			}
		}
		
		public function load():void
		{
			_loadedNum = 0;
			_thumbnails = [];
			
			var model:PhotoModel = PhotoModel.instance;
			for (var i:int = 0; i < model.items.length; i++)
			{
				var thumbnail:Thumbnail = new Thumbnail();
				thumbnail.load(model.items[i]);
				thumbnail.addEventListener("loadComplete", loadCompleteHandler);
				_thumbnails.push(thumbnail);
				
				var d:Number = 80;
				addChild(thumbnail);
				thumbnail.x = i % 6 * d;
				thumbnail.y = Math.floor(i / 6) * d;
			}
		}
		
		private function loadCompleteHandler(e:Event):void 
		{
			if (++_loadedNum >= PhotoModel.instance.items.length) {
				dispatchEvent(new Event("loadComplete"));
				open();
			}
		}
		
		private function clickThumbnailHandler(e:Event):void 
		{
			close();
		}
		
		
		
		
		private function open():void
		{
			for (var i:int = 0; i < _thumbnails.length; i++) 
			{
				var thumbnail:Thumbnail = _thumbnails[i];
				thumbnail.open(0.04 * i);
				thumbnail.addEventListener("clickThumbnail", clickThumbnailHandler);
			}
		}
		
		private function close():void
		{
			for (var i:int = 0; i < _thumbnails.length; i++) 
			{
				var thumbnail:Thumbnail = _thumbnails[i];
				thumbnail.close(0.02 * i);
				thumbnail.removeEventListener("clickThumbnail", clickThumbnailHandler);
			}
			
			var end:Function = ContentsModel.instance.dispatchEvent;
			var param:Array = [new Event("update")];
			BetweenAS3.delay(BetweenAS3.func( end, param), 1).play();
		}
		
		
		public function onResize(w:Number, h:Number):void
		{
			this.x = (w / 2 - 80 * 6 / 2) >> 0;
			this.y = (h / 2 - 80 * 5 / 2) >> 0;
			x += 74/2;
			y += 74/2;
		}
	}

}