package album.view 
{
	import album.model.ContentsModel;
	import album.vo.PhotoVo;
	import flash.display.Bitmap;
	import flash.display.Loader;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.MouseEvent;
	import flash.net.URLRequest;
	
	import org.libspark.betweenas3.BetweenAS3;
	import org.libspark.betweenas3.core.easing.IEasing;
	import org.libspark.betweenas3.easing.Circ;
	import org.libspark.betweenas3.easing.Expo;
	import org.libspark.betweenas3.tweens.ITween;
	/**
	 * ...
	 * @author Katsushi Suzuki
	 */
	public class Thumbnail extends Sprite
	{
		public var vo:PhotoVo;
		private var _base:Sprite;
		private var _cover:Sprite;
		private var _loader:Loader;
		private var _t:ITween;
		
		
		public function Thumbnail() 
		{
			buttonMode = true;
		}
		
		public function load(vo:PhotoVo):void
		{
			this.vo = vo;
			var url:String = "asset/"+vo.thumbnail;
			var req:URLRequest = new URLRequest(url);
			_loader = new Loader();
			_loader.x = -(74 / 2);
			_loader.y = -(74 / 2);
			_loader.contentLoaderInfo.addEventListener(Event.COMPLETE, loadImageCompleteHandler);
			_loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, loadImageErrorHandler);
			_loader.load(req);
			
			
			addEventListener(MouseEvent.MOUSE_OVER, overHandler);
			addEventListener(MouseEvent.MOUSE_OUT, outHandler);
			
			_base = addChild(new Sprite()) as Sprite;
			_base.addChild(_loader);
			_base.alpha = 0;
			_base.scaleX = _base.scaleY = 0;
			addEventListener(MouseEvent.MOUSE_DOWN, clickHandler);
			
			_cover = addChild(new Sprite()) as Sprite;
			_cover.graphics.beginFill(0xFFCC00, 0);
			_cover.graphics.drawRect(0, 0, 75, 75);
			_cover.x = -(74 / 2);
			_cover.y = -(74 / 2);
			mouseChildren = false;
		}
		
		public function open(time:Number):void
		{		
			if(_t)_t.stop();
			_t = BetweenAS3.tween( _base, { scaleX:1, scaleY:1, alpha:1 }, null, 0.5, Expo.easeOut);
			_t = BetweenAS3.delay(_t, time);
			_t.play();
			mouseEnabled = true;
			
			BetweenAS3.delay(BetweenAS3.tween( _cover, { scaleX:1, scaleY:1 }, null, 0.5, Expo.easeOut), time).play();
			
		}
		
		public function close(time:Number):void
		{
			if(_t)_t.stop();
			_t = BetweenAS3.tween( _base, { scaleX:0, scaleY:0, alpha:0 }, null, 0.7, Expo.easeOut);
			BetweenAS3.delay(_t, time).play();
			mouseEnabled = false;
			
			BetweenAS3.delay(BetweenAS3.tween( _cover, { scaleX:0, scaleY:0 }, null, 0.5, Expo.easeOut), time).play();
		}
		
		
		
		private function overHandler(e:MouseEvent):void 
		{
			if (_t)_t.stop();
			_t = BetweenAS3.tween( _base, { scaleX:0.9, scaleY:0.9, alpha:0.8 }, null, 0.4, Circ.easeOut);
			
			
			var brightness:uint = 150;
			BetweenAS3.tween( this, 
			{ transform: { colorTransform: { redOffset:0, greenOffset:0, blueOffset:0 }}}, 
			{ transform: { colorTransform: { redOffset:brightness, greenOffset:brightness, blueOffset:brightness  }}}, 
			0.3 ).play();
			
			_t.play();
		}
		
		private function outHandler(e:MouseEvent):void 
		{
			if(_t)_t.stop();
			_t = BetweenAS3.tween( _base, { scaleX:1, scaleY:1, alpha:1 }, null, 0.4, Circ.easeOut);
			_t.play();
		}
		
		private function clickHandler(e:MouseEvent):void
		{
			ContentsModel.instance.photoVo = vo;
			dispatchEvent(new Event("clickThumbnail"));
		}
		
		
		private function loadImageCompleteHandler(e:Event):void 
		{
			Bitmap(e.target.content).smoothing = true;
			dispatchEvent(new Event("loadComplete"));
		}
		
		private function loadImageErrorHandler(e:IOErrorEvent):void 
		{
		}
		
	}

}